import { ControlTypes } from "@/plugin-components/models/ControlTypes";
import { Selectable } from "@/plugin-components/models/Selectable";
import { IFormDefinition } from "@/plugin-components/models/IFormDefinition";
import { ValidatorDefinition } from "@/plugin-components/models/ValidatorDefinition";

export interface ControlDefinition {
  name: string;
  key: string;
  controlType: ControlTypes;
  validators?: ValidatorDefinition[];
  validationRules?: string;
  valueChanged?: (val: any) => void;
  valueLoadParser?: (val: any) => any;
  valueSaveParser?: (val: any) => any;
  helpText?: string;
  conditional?: Promise<boolean>;
}

export interface SelectableControlDefinition extends ControlDefinition {
  option: Promise<Selectable[]>;
  nullable: boolean;
  multiple: boolean;
}

export interface SubFormControlDefinition extends ControlDefinition {
  subForms: IFormDefinition;
  addSubFormFunction: () => void;
  removeSubFormFunction: (index: number) => void;
}

export interface FileUploadControlDefinition extends ControlDefinition {
  existingFiles: Promise<any[]>;
  removeFile: (id: string) => void;
  fileUploadPath: string;
}
