import { ControlDefinition } from "@/plugin-components/models/ControlDefinition";

export interface IFormDefinition {
  rows: Array<ControlDefinition[]>;
  submit: (val: any) => Promise<void>;
  model: any;
  title: string;
  formValidators?: any[];
}

export class FormDefinition implements IFormDefinition{
  constructor(title: string, model: any) {
    this._title = title;
    this._model = model;
    this._rows = [];
    this._submit = (val) => {
      return Promise.resolve();
    }
  }
  public get model() {
    return this._model;
  }
  public get rows() {
    return this._rows;
  }
  public get submit() {
    return this._submit;
  }
  public get title() {
    return this._title;
  }
  public set submit(val: (val: any) => Promise<void>) {
    this._submit = val;
  }
  public addRow(row: ControlDefinition[]): void {
    this._rows.push(row);
  }

  private readonly _model: any;
  private readonly _title: string;
  private _rows: Array<ControlDefinition[]>;
  private _submit: (val: any) => Promise<void>


}
